{"openapi":"3.1.0","info":{"title":"Verda Cloud Public API","description":"# Introduction\n\nVerda Cloud (formerly DataCrunch) API allows you to deploy, control instances & more via external code.\n\n## Open API schema\n\nDownload OpenAPI 3.1.0 schema here: [/v1/openapi.json](/v1/openapi.json)\n\nThe API is a RESTful API over HTTPS, all requests & responses use JSON as the data exchange format.\n\n## Official SDKs\n\nThe following SDK packages maintained by Verda Cloud and use this API:\n\n- **Python SDK**: https://github.com/verda-cloud/sdk-python\n- **Go SDK**: https://github.com/verda-cloud/verdacloud-sdk-go\n- **Terraform** and **OpenTofu** provider: https://github.com/verda-cloud/terraform-provider-verda\n\n<br/>\n\n# Quick Start Guide\n\nWe use [OAuth 2.0 Client Credentials](https://oauth.net/2/grant-types/client-credentials/) authentication scheme.\n\nYou can generate credentials via the console UI https://console.verda.com for external applications to use Verda API. The credentials are used to generate Access & Refresh tokens. All requests to this API must be authenticated using the Access token, except for a few open endpoints. Access tokens have a short lifespan, and can be regenerated using the Refresh token.\n\n## 1. Get Credentials from the Verda Cloud Dashboard\n\nGo to the Project page => **Keys** => **Cloud API Credentials** section and click on **Create**.\n\nThese credentials will be used like a username & password for your application. Store the client secret safely - like a password.\n\n<br/>\n\n## 2. Generate Access Token\n\nAn Access Token is needed to be sent with any API call for authentication. The Access Token has a limited lifetime and is expired after a while as defined in `expires_in`.\n\nIt is used as a [bearer token](https://developer.mozilla.org/en-US/docs/Web/HTTP/Authentication#bearer)\n\n<br/>\n\n### To get an access token, call the token endpoint with the credentials obtained in step 1:\n\n```json http\n{\n  \"method\": \"post\",\n  \"url\": \"https://api.verda.com/v1/oauth2/token\",\n  \"headers\": {\n    \"Content-Type\": \"application/json\"\n  },\n  \"body\": {\n    \"grant_type\": \"client_credentials\",\n    \"client_id\": \"<YOUR_CLIENT_ID>\",\n    \"client_secret\": \"<YOUR_CLIENT_SECRET>\"\n  }\n}\n```\n\nA valid response would look similar to this:\n\n```json\n{\n  \"access_token\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJoZXkiOiJ5b3UgYWN1YWxseSBjaGVja2VkIHRoaXM_In0.0RjcdKQ1NJP9gbRyXITE6LFFLwKGzeeshuubnkkfkb8\",\n  \"token_type\": \"Bearer\",\n  \"expires_in\": 3600,\n  \"refresh_token\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ3b3ciOiJhbmQgdGhpcyB0b28_In0.AC5gk-o-MOptUgrouEErlhr8WT3Hg_RR6px6A0I7ZEk\",\n  \"scope\": \"cloud-api-v1\"\n}\n```\n\n`access_token` is the token value, to be used in the next step.\n\n`expires_in` is the duration in seconds until the token is expired.\n\n`refresh_token` can be used to create a new access token if expired.\n\nWhen an Access Token expires, create a new one using the refresh token:\n\n```json http\n{\n  \"method\": \"post\",\n  \"url\": \"https://api.verda.com/v1/oauth2/token\",\n  \"headers\": {\n    \"Content-Type\": \"application/json\"\n  },\n  \"body\": {\n    \"grant_type\": \"refresh_token\",\n    \"refresh_token\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ3b3ciOiJhbmQgdGhpcyB0b28_In0.AC5gk-o-MOptUgrouEErlhr8WT3Hg_RR6px6A0I7ZEk\"\n  }\n}\n```\n\nThe response will include a new token.\n\n<br/>\n\n## 3. Make REST API Calls\n\nThat's it, you are ready to use the API, don't forget to add the Access Token to your calls:\n\nLet's call the `/balance` endpoint.\n\nAdd the Access Token value to the `Authorization` header, preceded by the \"Bearer\" string and a space:\n\n```json http\n{\n  \"method\": \"get\",\n  \"url\": \"https://api.verda.com/v1/balance\",\n  \"headers\": {\n    \"Authorization\": \"Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJoZXkiOiJ5b3UgYWN1YWxseSBjaGVja2VkIHRoaXM_In0.0RjcdKQ1NJP9gbRyXITE6LFFLwKGzeeshuubnkkfkb8\"\n  }\n}\n```\n\n<br/>\n\n# Rate Limits\n\nAuthenticated public API requests are rate limited per project in 60 second windows.\n\n## Limits enforced\n\n- **Project limit**: 500 requests per minute for all authenticated API requests made for the same project\n- **Endpoint limit**: 60 requests per minute for the same project, HTTP method, and request path combination\n\nThe endpoint limit key includes the full request path. Route-specific endpoint policies override the regular endpoint limit for the matching request path.\n\n## Headers\n\nRate limit information is returned in response headers on authenticated requests:\n\n- `RateLimit-Policy`: configured limits and window\n- `RateLimit`: current remaining quota and reset time per limit\n\nIf a limit is exceeded, the API will return HTTP `429 Too Many Requests` and also include a `Retry-After` header with the number of seconds until requests are allowed again.\n\n### Example of successful response with rate limits policy specified\n\n```\ncurl -X GET --verbose https://api.verda.com/v1/instances\nHTTP/1.1 200 OK\nContent-Type: application/json; charset=utf-8\nContent-Length: 213\nRateLimit-Policy: \"project\";q=500;w=60, \"endpoint\";q=60;w=60\nRateLimit: \"project\";r=486;t=37, \"endpoint\";r=48;t=37\n\n{...}\n```\n\n### Example of throttled response\n\n```\ncurl -X GET --verbose https://api.verda.com/v1/instances\n\nHTTP/1.1 429 Too Many Requests\nContent-Type: application/json; charset=utf-8\nContent-Length: 11\nRateLimit-Policy: \"project\";q=500;w=60, \"endpoint\";q=50;w=60\nRateLimit: \"project\";r=419;t=44, \"endpoint\";r=0;t=49\nRetry-After: 49\n```\n\n<br/>\n\n# Pagination\n\nSome endpoints support pagination using the `page` and `pageSize` query parameters. For backward compatibility, pagination does not change the JSON response payload format. Instead, clients request a page with query parameters and read pagination metadata from response headers.\n\n## Request and response format\n\n- `page`: `1`\n- `pageSize`: `10` (can be extended to a maximum of 100 records per page)\n\nWhen pagination is available, the response includes these headers:\n\n- `X-Page`: current page number\n- `X-Page-Size`: current page size\n- `X-Total-Count`: total number of matching items\n\nExample request:\n\n```\nGET /v1/scripts?page=1&pageSize=100\n```\n\nExample response:\n\n```\nHTTP/1.1 200 OK\nContent-Type: application/json\nContent-Length: 11111\nX-Page: 1\nX-Page-Size: 100\nX-Total-Count: 10000\n\n[{ \"id\": \"2b1af58-7537-4edb-ba81-82cee082c5e9\", \"name\": \"My startup script\" }]\n```\n\n<br/>\n\n# Errors\n\nError response body has following schema:\n\n| Key     | Info                                     |\n| ------- | ---------------------------------------- |\n| code    | Error type                               |\n| message | Textual description of the error details |\n\n## Error types\n\n| Code                 | Description                                                                     | Matching HTTP error code |\n| -------------------- | ------------------------------------------------------------------------------- | ------------------------ |\n| invalid_request      | Invalid request, usually an input error - missing or invalid property etc.      | 400                      |\n| unauthorized_request | Access token is missing or invalid                                              | 401                      |\n| insufficient_funds   | Not enough funds to perform the action                                          | 402                      |\n| forbidden_action     | Can't perform the current action                                                | 403                      |\n| not_found            | Resource not found, or invalid path                                             | 404                      |\n| rate_limit_exceeded  | Too many requests for the current project or endpoint window                    | 429                      |\n| server_error         | Error on datacrunch's side                                                      | 500                      |\n| service_unavailable  | Not enough resources at the moment, try again later or use a different resource | 503                      |\n\n<br/>\n\n# Changelog\n\n## 2026-03-30 Startup script quota and pagination\n\nTotal number of startup scripts in a project now limited by a per-user quota with a default of `100` scripts and a hard maximum of `10000`.\n\n`GET /v1/scripts` now supports pagination via the `page` and `pageSize` query parameters. For backward compatibility, the response payload shape is unchanged and pagination metadata is returned in headers instead. See the [Pagination](#pagination) section for details.\n\n## 2026-03-20 Scope-based access control for API tokens\n\nAPI tokens created via the OAuth 2.0 Client Credentials flow are now issued with the scope `cloud-api-v1` and restricted to documented Public API endpoints only. Previously, these tokens could access internal endpoints not intended for external use. If you are using API tokens for any undocumented endpoints, those requests will now return `403 Forbidden` with `\"Insufficient scope\"`. Only the endpoints listed in this API documentation are accessible with API tokens.\n\n## 2026-03-20 Long term periods endpoints\n\n`GET /v1/long-term/periods` is now **deprecated**. Use the dedicated endpoints instead:\n\n- [GET /v1/long-term/periods/instances](/v1/docs#tag/Long-Term/GET/v1/long-term/periods/instances) — long term periods for instances\n- [GET /v1/long-term/periods/clusters](/v1/docs#tag/Long-Term/GET/v1/long-term/periods/clusters) — long term periods for clusters\n\nImproved OpenAPI documentation for all long term period endpoints with detailed property descriptions and examples.\n\n## 2026-03-19 Property `location_code` is now required\n\nThe location_code property is now required in the request body when creating instances, clusters, and volumes via the Public API. Requests that omit it will receive an HTTP 400 Bad Request response instead of silently defaulting to FIN-01. This brings the API in line with the SDK, where specifying a region has always been mandatory.\n\nBreakdown of API changes:\n\n| Description                                                | Endpoint             | Schema change                                   |\n| ---------------------------------------------------------- | -------------------- | ----------------------------------------------- |\n| [Deploy instance](#tag/instances/POST/v1/instances)        | `POST /v1/instances` | `{ /* required */ location_code: string, ... }` |\n| [Deploy cluster](#tag/clusters/POST/v1/clusters)           | `POST /v1/clusters`  | `{ /* required */ location_code: string, ... }` |\n| [Create block volume or SFS](#tag/volumes/POST/v1/volumes) | `POST /v1/volumes`   | `{ /* required */ location_code: string, ... }` |\n\n## 2026-03-19 OpenAPI spec auth fix\n\nFixed the OpenAPI specification incorrectly requiring bearer authentication on public endpoints (`/v1/instance-types`, `/v1/cluster-types`, `/v1/container-types`, `/v1/long-term/periods`). These endpoints are publicly accessible and no longer show an authentication requirement in the spec.\n\n## 2026-03-16 Volume response improvements\n\n`GET /v1/volumes/{id}` now includes `is_permanently_deleted` and `deleted_at` fields when the volume is in `deleted` status. These fields are omitted for active volumes. The OpenAPI schema for this endpoint now uses `oneOf` to distinguish between the active-volume and deleted-volume response shapes.\n\n## 2026-03-12 Improved instance action and volume deletion responses\n\nBulk instance actions (`PUT /v1/instances`) now return structured per-action results. Each result includes the instance `id`, a `status` (`success` or `error`), and an `error` message when applicable. When all actions succeed the response is `202 Accepted`; when some fail, you receive a `207 Multi-Status` with individual outcomes. A single-instance action that is already in the requested state now returns `204 No Content` instead of an error.\n\nVolume deletion (`DELETE /v1/volumes/{id}`) now returns `204 No Content` when the volume is already deleted, making the operation idempotent.\n\nOpenAPI schema fields that accept both a single UUID string and an array of UUIDs (`id`, `ssh_key_ids`, `volume_ids`) are now documented with `oneOf` for accurate client generation.\n\n## 2026-03-11 API rate limits\n\nIntroduced rate limits to our Public API to ensure the stability of our API and platform for everyone. Rate limits are restrictions our API enforces on how frequently a user or client can make requests to our services within a given timeframe.\n\nPlease take a look at our API documentation section [\"Rate limits\"](https://api.verda.com/v1/docs#description/rate-limits).\n\n## 2026-02-03 Spot instance volume policy\n\nWhen creating a spot instance, it is now possible to specify a removal policy for the OS volume and any additional volumes created alongside it. Use the `on_spot_discontinue` field:\n\n[POST /v1/instances](/v1/docs#tag/instances/POST/v1/instances)\n\n```js\nPOST v1/instances\n{\n  \"instance_type\": \"CPU.4V.16G\",\n  \"image\": \"ubuntu-24.04\",\n  \"ssh_key_ids\": [\"442e6a59-26c2-4cea-a619-39762c0d2385\"],\n  \"hostname\": \"test-instance\",\n  \"location_code\": \"FIN-03\",\n  \"is_spot\": true,\n  \"os_volume\": {\n    \"name\": \"test-instance-os-volume\",\n    \"size\": 55,\n    // If \"delete_permanently\", the volume will be deleted when the spot instance is discontinued\n    \"on_spot_discontinue\": \"keep_detached\" | \"move_to_trash\" | \"delete_permanently\"\n  }\n}\n```\n\n## 2026-02-03 Delete volumes permanently when deleting an instance\n\nWhen deleting an instance, you can now specify whether its volumes should be moved to deleted storage (default) or deleted permanently:\n\n[PUT /v1/instances](/v1/docs#tag/instances/PUT/v1/instances)\n\n```js\nPUT v1/instances\n{\n  \"action\": \"delete\",\n  \"id\": \"442e6a59-26c2-4cea-a619-39762c0d2385\",\n  \"volume_ids\": [\"5e9e63a9-fc3b-427b-b259-0c77dce61090\"],\n  // Will delete the instance and volumes permanently\n  \"delete_permanently\": true\n}\n```\n","version":"v1","contact":{"name":"Verda Cloud Oy","url":"https://verda.com","email":"info@verda.com"}},"servers":[{"url":"https://api.verda.com"}],"security":[{"bearer":[]}],"tags":[{"name":"Clusters","description":"Deploy and manage clusters.\n      \n**Beta:** Clusters API is under active development and may change without notice."},{"name":"SSH Keys","description":"Manage SSH keys to access your instances and clusters.\n\n**Note**: `/v1/sshkeys` endpoints are deprecated. Use `/v1/ssh-keys` instead."},{"name":"Startup Scripts","description":"Manage startup scripts to be run when instance are started. One project can have up to 100 startup scripts (configurable quota up to 10000)."}],"paths":{"/v1/oauth2/token":{"post":{"description":"Get access token for public API using client credentials or refresh token.You can manage your credentials at https://console.verda.com, under the **Keys** => **Cloud API credentials** section.","operationId":"Oauth2Controller_getAccessToken","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/GetAccessTokenDto"},{"$ref":"#/components/schemas/RefreshAccessTokenPublicApiDto"}]}}}},"responses":{"200":{"description":"Valid credentials","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetAccessTokenResponseDto"}}}},"400":{"description":"Invalid request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PublicApiErrorResponseDto"},"example":{"code":"invalid_request","message":"unsupported grant type"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PublicApiErrorResponseDto"},"example":{"code":"unauthorized_request","message":"Invalid client id or client secret"}}}}},"summary":"Get access token","tags":["Authentication"],"security":[]}},"/v1/balance":{"get":{"operationId":"BalanceController_getBalance","parameters":[],"responses":{"200":{"description":"Returns the project balance","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BalanceResponseDto"}}}}},"security":[{"bearer":[]}],"summary":"Get project balance","tags":["Balance"]}},"/v1/images":{"get":{"operationId":"ImagesController_getImageTypes","parameters":[{"name":"instance_type","required":false,"in":"query","description":"Filter OS images by instance type. Default is all instance images.","schema":{"example":"1A100.22V","type":"string"}}],"responses":{"200":{"description":"Returns available image types for instances","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Os"}}}}},"404":{"description":"Instance type not found"}},"security":[{"bearer":[]}],"summary":"Get images types for instances","tags":["Images","OS Images"]}},"/v1/images/cluster":{"get":{"operationId":"ImagesController_getClusterImageTypes","parameters":[{"name":"instance_type","required":false,"in":"query","description":"Filter OS images by instance type. Default is all cluster images.","schema":{"example":"16B200","type":"string"}}],"responses":{"200":{"description":"Returns available image types for cluster","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Os"}},"example":[{"id":"e79a91e9-8750-44cb-af19-bf6ab83121ee","image_type":"ubuntu-22.04-cuda-12.4-cluster","name":"Ubuntu 24.04","is_default":false,"is_cluster":true,"details":["Ubuntu 22.04","CUDA 12.4"]}]}}},"404":{"description":"Instance type not found"}},"security":[{"bearer":[]}],"summary":"Get images types for cluster","tags":["Images","Clusters"]}},"/v1/volumes":{"get":{"operationId":"VolumesController_getVolumes","parameters":[{"name":"status","required":false,"in":"query","description":"Get volumes with this status. Optional","schema":{"example":"attached","enum":["ordered","attached","attaching","detached","deleted","cloning","detaching","deleting","restoring","created","exported","canceled","canceling"],"type":"string"}}],"responses":{"200":{"description":"Returns a list of all volumes\n\n### Rate limits\n\nThis endpoint is rate limited to 120 requests per minute per project.","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetVolumePublicResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get all volumes","tags":["Volumes"]},"post":{"operationId":"VolumesController_createVolume","parameters":[{"name":"user-agent","required":true,"in":"header","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateVolumePublicDto"}}}},"responses":{"202":{"description":"Volume ID","content":{"application/json":{"example":"1cc89213-1720-4257-84c7-b35acc09015a"}}},"403":{"description":"One or more of the specified instances is not shut down"}},"security":[{"bearer":[]}],"summary":"Create volume","tags":["Volumes"]},"put":{"operationId":"VolumesController_performActions","parameters":[{"name":"user-agent","required":true,"in":"header","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PerformVolumeActionPublicDto"}}}},"responses":{"202":{"description":""}},"security":[{"bearer":[]}],"summary":"Perform action on a volume or multiple volumes","tags":["Volumes"]}},"/v1/volumes/trash":{"get":{"operationId":"VolumesController_getVolumesInTrash","parameters":[],"responses":{"200":{"description":"Returns a list of all volumes in trash","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetVolumeInTrashPublicResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get all volumes that are in trash","tags":["Volumes"]}},"/v1/volumes/{volume_id}":{"get":{"operationId":"VolumesController_getVolumeById","parameters":[{"name":"volume_id","required":true,"in":"path","schema":{"example":"c519f390-a8b6-4e59-b5bb-8457e717d21b","type":"string"}}],"responses":{"200":{"description":"Returns volume details","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/GetVolumePublicResponseDto"},{"$ref":"#/components/schemas/GetVolumeInTrashPublicResponseDto"}]}}}}},"security":[{"bearer":[]}],"summary":"Get volume by id","tags":["Volumes"]},"delete":{"operationId":"VolumesController_deleteVolumeById","parameters":[{"name":"volume_id","required":true,"in":"path","schema":{"example":"8d30c0b7-9ce8-49ce-807b-4b355381cffe","type":"string"}},{"name":"user-agent","required":true,"in":"header","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteVolumePublicDto"}}}},"responses":{"202":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete volume by id","tags":["Volumes"]}},"/v1/volume-types":{"get":{"operationId":"VolumeTypesController_getVolumeTypes","parameters":[],"responses":{"200":{"description":"Returns the list of available volume types","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/VolumeType"}}}}}},"security":[],"summary":"Get volume types","tags":["Volume Types"]}},"/v1/instances":{"get":{"description":"Return all instances of the project, or all instances with a specific status (optional)\n\n### Rate limits\n\nThis endpoint is rate limited to 120 requests per minute per project.\n","operationId":"InstancesController_getInstances","parameters":[{"name":"status","required":false,"in":"query","description":"Get compute deployments with selected status. Optional","schema":{"enum":["running","provisioning","offline","discontinued","unknown","ordered","notfound","new","error","deleting","validating","no_capacity","installation_failed"],"type":"string"}},{"name":"computeId","required":false,"in":"query","description":"Get one compute by computeId. Optional","schema":{"type":"string"}}],"responses":{"200":{"description":"Instance or a list of instances","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetInstanceResponsePublicApiDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get instances","tags":["Instances"]},"post":{"description":"\nDeploy a new instance.\n\nBefore deploying an instance, you need to add at least ssh key to be able to access your instance.\n\nInstance types can be listed using the `GET /instance-types` endpoint.\n\nAvailable images can be listed using the `GET /images` endpoint, using the `image_type` value from the result.\n\nExisting detached OS volumes could be used as an image, put the volume ID as the `image` value.\n\nIt's also possible to define new volumes that will be created and attached to the new instance. New volumes location will be the same as the instance.\n\nExisting detached volumes can be attached to the deployed instance by adding their IDs to the `existing_volumes` property.\n    ","operationId":"InstancesController_deployInstance","parameters":[{"name":"user-agent","required":true,"in":"header","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeployInstancePublicDto"}}}},"responses":{"202":{"description":"Instance ID","content":{"application/json":{"example":"b6a57e8c-d8af-4dd7-be9d-7d79f8575a90"}}}},"security":[{"bearer":[]}],"summary":"Deploy instance","tags":["Instances"]},"put":{"description":"\nPerform an action on a single or multiple instances.\n\nNote: to `hibernate` an instance, you must first `shutdown` it. All instance volumes would be detached and the instance will be deleted.\n\n**Important**: To remove an instance and stop charging your account, you must `delete` it. Using `shutdown` will keep charging your account.\n\nWhen deleting an instance, you can specify which of its' attached volumes will be deleted by providing `volume_ids` array. Any attached volumes that are not specified in the array would be detached.\n\nNote: If not providing a `volume_ids` array, only the OS volume will be deleted and the rest detached.\n    ","operationId":"InstancesController_performActions","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PerformInstanceActionPublicDto"}}}},"responses":{"202":{"description":"All actions completed successfully","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceActionResultDto"}}}}},"204":{"description":"Instance is already in the requested state (single action only)"},"207":{"description":"Some actions failed - returns per-action results with individual statuses and errors","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceActionResultDto"}}}}},"400":{"description":"Invalid request or action not allowed (single action only)"},"404":{"description":"Instance not found (single action only)"}},"security":[{"bearer":[]}],"summary":"Perform action on an instance or multiple instances","tags":["Instances"]}},"/v1/instances/types":{"get":{"deprecated":true,"operationId":"InstancesController_getInstanceTypesDeprecated","parameters":[],"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Get instance types - deprecated","tags":["Instances"]}},"/v1/instances/{instance_id}":{"get":{"operationId":"InstancesController_getInstanceById","parameters":[{"name":"instance_id","required":true,"in":"path","schema":{"example":"0e50ba5a-434e-4c48-9ce6-aeba7f92251b","type":"string"}}],"responses":{"200":{"description":"Instance details","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetInstanceResponsePublicApiDto"}}}}},"security":[{"bearer":[]}],"summary":"Get instance by id","tags":["Instances"]}},"/v1/instances/availability/{instanceType}":{"get":{"deprecated":true,"operationId":"InstancesController_checkAvailabilityDeprecated","parameters":[{"name":"instanceType","required":true,"in":"path","schema":{"type":"string"}}],"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Check instance type availability - deprecated","tags":["Instances"]}},"/v1/instances/action":{"post":{"deprecated":true,"operationId":"InstancesController_performActionDeprecated","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PerformInstanceActionPublicDto"}}}},"responses":{"202":{"description":""}},"security":[{"bearer":[]}],"summary":"Perform action - deprecated","tags":["Instances"]}},"/v1/clusters":{"get":{"description":"Return all clusters of the project","operationId":"ClustersController_getInstances","parameters":[],"responses":{"200":{"description":"List of clusters","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetClusterResponsePublicApiDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get clusters","tags":["Clusters"]},"post":{"description":"\nDeploy a new cluster.\n\nBefore deploying add at least one SSH key to enable access to your cluster.\n\nCluster types can be listed using the `GET /v1/cluster-types` endpoint. Image types can be listed using the `GET /v1/images/cluster` endpoint.\n     ","operationId":"ClustersController_deployCluster","parameters":[{"name":"user-agent","required":true,"in":"header","schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeployClusterPublicDto"}}}},"responses":{"202":{"description":"Cluster deployed","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeployClusterResponsePublicApiDto"}}}}},"security":[{"bearer":[]}],"summary":"Deploy cluster","tags":["Clusters"]},"put":{"description":"Perform actions on one or more clusters.\n\nNote: Only `discontinue` action is allowed for clusters.\n\n**Important**: Local OS storage will be deleted. Shared volumes will be detached and should be deleted manually.\n    ","operationId":"ClustersController_performActions","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PerformClusterActionsBulkDto"}}}},"responses":{"202":{"description":""}},"security":[{"bearer":[]}],"summary":"Perform action on clusters","tags":["Clusters"]}},"/v1/clusters/{id}":{"get":{"operationId":"ClustersController_getClusterById","parameters":[{"name":"id","required":true,"in":"path","schema":{"example":"80d93482-c2df-4f14-befe-616b9ee86d9a","type":"string"}}],"responses":{"200":{"description":"Cluster details","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetClusterResponsePublicApiDto"}}}}},"security":[{"bearer":[]}],"summary":"Get cluster by id","tags":["Clusters"]}},"/v1/clusters/{clusterId}/nodes/{nodeId}/actions":{"post":{"description":"Start or shut down a single node inside a cluster (worker, jumphost, or CPU service node).\n\n    Supported `action` values:\n    - `boot` — start the node\n    - `shutdown` — graceful shutdown\n    - `force_shutdown` — force the node off\n    ","operationId":"ClustersController_performClusterNodeAction","parameters":[{"name":"clusterId","required":true,"in":"path","schema":{"example":"3652fd53-5cbc-4691-8fe2-cd609d37bbf5","type":"string"}},{"name":"nodeId","required":true,"in":"path","schema":{"example":"6d644339-09c9-40ae-84ae-69bab391ac3a","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PerformClusterNodeActionPublicDto"}}}},"responses":{"202":{"description":"Action dispatched"},"400":{"description":"Invalid action"},"404":{"description":"Cluster or node not found"}},"security":[{"bearer":[]}],"summary":"Perform action on a cluster node","tags":["Clusters"]}},"/v1/instance-types":{"get":{"operationId":"InstanceTypesController_getInstanceTypes","parameters":[{"name":"currency","required":false,"in":"query","description":"Currency to get the price history for","schema":{"default":"usd","example":"usd","enum":["usd","eur"],"type":"string"}}],"responses":{"200":{"description":"","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceType"}}}}}},"summary":"Get instance types","tags":["Instance Types"],"security":[]}},"/v1/instance-types/price-history":{"get":{"deprecated":true,"operationId":"InstanceTypesController_getDailyDynamicPriceHistory","parameters":[],"responses":{"200":{"description":""}},"summary":"Get daily dynamic price history (only the last price update per day) - Not supported anymore","tags":["Instance Types"],"security":[]}},"/v1/instance-availability":{"get":{"operationId":"InstanceAvailabilityController_getAllAvailabilities","parameters":[{"name":"locationCode","required":false,"in":"query","description":"Deprecated camelCase alias for location_code.","schema":{"example":"FIN-01","type":"string"}},{"name":"is_spot","required":false,"in":"query","description":"Check spot instance availability","schema":{"default":"false","example":"false","type":"string"}},{"name":"location_code","required":false,"in":"query","description":"Check availability for a specific location code. If omitted, all locations are checked.","schema":{"example":"FIN-01","type":"string"}}],"responses":{"200":{"description":"Returns the instance type availabilities for all locations","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceAvailabilityResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get all instance type availabilities for all locations","tags":["Instance Availability"]}},"/v1/instance-availability/{instance_type}":{"get":{"operationId":"InstanceAvailabilityController_checkAvailability","parameters":[{"name":"instance_type","required":true,"in":"path","description":"The type of instance to check","schema":{"example":"1H100.80S.22V","type":"string"}},{"name":"locationCode","required":false,"in":"query","description":"Deprecated camelCase alias for location_code.","schema":{"example":"FIN-01","type":"string"}},{"name":"is_spot","required":false,"in":"query","description":"Check spot instance availability","schema":{"default":"false","example":"false","type":"string"}},{"name":"location_code","required":false,"in":"query","description":"Check availability for a specific location code. If omitted, all locations are checked.","schema":{"example":"FIN-01","type":"string"}}],"responses":{"200":{"description":"Returns the instance type availability","content":{"application/json":{"schema":{"type":"boolean"}}}}},"security":[{"bearer":[]}],"summary":"Get instance type availability","tags":["Instance Availability"]}},"/v1/cluster-availability":{"get":{"operationId":"ClusterAvailabilityController_getAllAvailabilities","parameters":[{"name":"location_code","required":false,"in":"query","description":"Check availability for a specific location code. By default, all locations are checked.","schema":{"example":"FIN-03","type":"string"}}],"responses":{"200":{"description":"Returns the cluster type availabilities for specific location","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ClusterAvailabilityResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get all cluster types availability","tags":["Clusters"]}},"/v1/cluster-availability/{cluster_type}":{"get":{"operationId":"ClusterAvailabilityController_checkAvailability","parameters":[{"name":"cluster_type","required":true,"in":"path","description":"The type of cluster to check","schema":{"example":"16B200","type":"string"}},{"name":"location_code","required":false,"in":"query","description":"Check availability for a specific location code. By default, all locations are checked.","schema":{"example":"FIN-03","type":"string"}}],"responses":{"200":{"description":"Returns the cluster type availability","content":{"application/json":{"schema":{"type":"boolean"}}}}},"security":[{"bearer":[]}],"summary":"Get specific cluster type availability","tags":["Clusters"]}},"/v1/sshkeys":{"get":{"operationId":"SshkeysController_getKeys[0]","parameters":[],"responses":{"200":{"description":"Returns a list of the project's SSH keys","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetKeysResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get SSH keys","tags":["SSH Keys"]},"post":{"operationId":"SshkeysController_addKey[0]","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddKeyDto"}}}},"responses":{"201":{"description":"Returns the ID of the newly created SSH key","content":{"application/json":{"example":"39479972-f06d-4a94-8027-75a0b42dcf6b"}}}},"security":[{"bearer":[]}],"summary":"Add new SSH key","tags":["SSH Keys"]},"delete":{"operationId":"SshkeysController_deleteKeys[0]","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteKeysPublicDto"}}}},"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete ssh keys","tags":["SSH Keys"]}},"/v1/ssh-keys":{"get":{"operationId":"SshkeysController_getKeys[1]","parameters":[],"responses":{"200":{"description":"Returns a list of the project's SSH keys","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetKeysResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get SSH keys","tags":["SSH Keys"]},"post":{"operationId":"SshkeysController_addKey[1]","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddKeyDto"}}}},"responses":{"201":{"description":"Returns the ID of the newly created SSH key","content":{"application/json":{"example":"39479972-f06d-4a94-8027-75a0b42dcf6b"}}}},"security":[{"bearer":[]}],"summary":"Add new SSH key","tags":["SSH Keys"]},"delete":{"operationId":"SshkeysController_deleteKeys[1]","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteKeysPublicDto"}}}},"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete ssh keys","tags":["SSH Keys"]}},"/v1/sshkeys/{sshKeyId}":{"get":{"operationId":"SshkeysController_getKey[0]","parameters":[{"name":"sshKeyId","required":true,"in":"path","schema":{"example":"1dd78689-0420-43fa-b49b-e9c135ebf892","type":"string"}}],"responses":{"200":{"description":"Returns the SSH key","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetKeysResponseDto"}}}}},"security":[{"bearer":[]}],"summary":"Get single SSH key by ID","tags":["SSH Keys"]},"delete":{"operationId":"SshkeysController_deleteKey[0]","parameters":[{"name":"sshKeyId","required":true,"in":"path","schema":{"example":"6c5f147f-8e5c-48d3-a0a3-0d0b168f0311","type":"string"}}],"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete single SSH key by ID","tags":["SSH Keys"]}},"/v1/ssh-keys/{sshKeyId}":{"get":{"operationId":"SshkeysController_getKey[1]","parameters":[{"name":"sshKeyId","required":true,"in":"path","schema":{"example":"1dd78689-0420-43fa-b49b-e9c135ebf892","type":"string"}}],"responses":{"200":{"description":"Returns the SSH key","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetKeysResponseDto"}}}}},"security":[{"bearer":[]}],"summary":"Get single SSH key by ID","tags":["SSH Keys"]},"delete":{"operationId":"SshkeysController_deleteKey[1]","parameters":[{"name":"sshKeyId","required":true,"in":"path","schema":{"example":"6c5f147f-8e5c-48d3-a0a3-0d0b168f0311","type":"string"}}],"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete single SSH key by ID","tags":["SSH Keys"]}},"/v1/scripts":{"get":{"operationId":"ScriptsController_getScripts","parameters":[{"name":"page","required":false,"in":"query","description":"Page number, starting from 1","schema":{"default":"1","type":"number"}},{"name":"pageSize","required":false,"in":"query","description":"Number of items per page, default 10 maximum 100","schema":{"default":"10","type":"number"}},{"name":"name","required":false,"in":"query","description":"Name filter. Startup scripts match by a partial name.","schema":{"type":"string"}}],"responses":{"200":{"description":"Returns a list of the project's startup scripts","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetScriptResponseDto"}}}}}},"security":[{"bearer":[]}],"summary":"Get startup scripts","tags":["Startup Scripts"]},"post":{"operationId":"ScriptsController_addScript","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddScriptDto"}}}},"responses":{"201":{"description":"Returns the ID of the newly created script","content":{"application/json":{"example":"a2f111ae-9b82-4982-8d66-4e7faadef063"}}}},"security":[{"bearer":[]}],"summary":"Add new startup script","tags":["Startup Scripts"]},"delete":{"operationId":"ScriptsController_deleteScripts","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteScriptsDto"}}}},"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete startup scripts","tags":["Startup Scripts"]}},"/v1/scripts/{scriptId}":{"get":{"operationId":"ScriptsController_getScript","parameters":[{"name":"scriptId","required":true,"in":"path","schema":{"example":"d7caf194-8d1f-40bb-9d44-100177b96973","type":"string"}}],"responses":{"200":{"description":"Return startup script with specific ID","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetScriptResponseDto"}}}}},"security":[{"bearer":[]}],"summary":"Get single startup script by ID","tags":["Startup Scripts"]},"delete":{"operationId":"ScriptsController_deleteKey","parameters":[{"name":"scriptId","required":true,"in":"path","schema":{"example":"05860ea7-7b1b-4ebb-9d3f-9715f6942eb6","type":"string"}}],"responses":{"200":{"description":""}},"security":[{"bearer":[]}],"summary":"Delete single startup script by ID","tags":["Startup Scripts"]}},"/v1/locations":{"get":{"operationId":"LocationsController_getVolumeTypes","parameters":[],"responses":{"200":{"description":"Returns a list of available locations","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Location"}}}}}},"security":[{"bearer":[]}],"summary":"Returns a list of available locations","tags":["Locations"]}},"/v1/long-term/periods":{"get":{"deprecated":true,"operationId":"LongTermController_getLongTermPeriodsDeprecated","parameters":[],"responses":{"200":{"description":"Returns the long term periods","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/LongTermPeriodResponseDto"}}}}}},"summary":"Get long term periods","tags":["Long Term"],"security":[]}},"/v1/long-term/periods/instances":{"get":{"operationId":"LongTermController_getLongTermPeriodsInstances","parameters":[],"responses":{"200":{"description":"Returns the long term periods for instances","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/LongTermPeriodResponseDto"}}}}}},"summary":"Get long term periods for instances","tags":["Long Term"],"security":[]}},"/v1/long-term/periods/clusters":{"get":{"operationId":"LongTermController_getLongTermPeriodsClusters","parameters":[],"responses":{"200":{"description":"Returns the long term periods for clusters","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/LongTermPeriodResponseDto"}}}}}},"summary":"Get long term periods for clusters","tags":["Long Term"],"security":[]}},"/v1/cluster-types":{"get":{"operationId":"ClusterTypesController_getInstanceTypes","parameters":[{"name":"currency","required":false,"in":"query","description":"Currency to get the price for cluster types","schema":{"default":"usd","example":"usd","enum":["usd","eur"],"type":"string"}}],"responses":{"200":{"description":"","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ClusterType"}}}}}},"summary":"Get cluster types","tags":["Clusters"],"security":[]}},"/v1/container-types":{"get":{"operationId":"ContainerTypesController_getContainerTypes","parameters":[{"name":"currency","required":false,"in":"query","description":"Currency to get the price history for","schema":{"default":"usd","example":"usd","enum":["usd","eur"],"type":"string"}}],"responses":{"200":{"description":"","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ContainerType"}}}}}},"summary":"Get container types","tags":["Container Types"],"security":[]}},"/v1/job-deployments":{"get":{"operationId":"ScaledJobPublicApiController_getList","parameters":[],"responses":{"200":{"description":"Fetch a list of job deployments","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ScaledJobShortInfoResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get all job deployments","tags":["Serverless Jobs"]},"post":{"operationId":"ScaledJobPublicApiController_createNewScaledJob","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateScaledJobDto"}}}},"responses":{"201":{"description":"Returns the created job","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScaledJobResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Create new job","tags":["Serverless Jobs"]}},"/v1/job-deployments/{jobName}":{"get":{"operationId":"ScaledJobPublicApiController_getByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"responses":{"200":{"description":"Fetch a job deployment by name","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScaledJobResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get job deployment by name","tags":["Serverless Jobs"]},"patch":{"operationId":"ScaledJobPublicApiController_updateScaledJobByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchScaledJobDto"}}}},"responses":{"200":{"description":"Returns the updated job deployment","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScaledJobResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Update job deployment","tags":["Serverless Jobs"]},"delete":{"operationId":"ScaledJobPublicApiController_deleteByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}},{"name":"timeout","required":false,"in":"query","description":"Maximum time to wait for job deployment deletion in milliseconds. Set to 0 to skip waiting.","schema":{"minimum":0,"maximum":300000,"default":60000,"example":60000,"type":"number"}}],"responses":{"200":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Delete job deployment","tags":["Serverless Jobs"]}},"/v1/job-deployments/{jobName}/scaling":{"get":{"operationId":"ScaledJobPublicApiController_getScalingOptionsByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"responses":{"200":{"description":"Scaling options","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScalingOptionsResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get job deployment scaling options","tags":["Serverless Jobs"]}},"/v1/job-deployments/{jobName}/purge-queue":{"post":{"operationId":"ScaledJobPublicApiController_purgeQueue","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Purge job deployment queue","tags":["Serverless Jobs"]}},"/v1/job-deployments/{jobName}/pause":{"post":{"operationId":"ScaledJobPublicApiController_pauseScaledJobByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Pause job deployment","tags":["Serverless Jobs"]}},"/v1/job-deployments/{jobName}/resume":{"post":{"operationId":"ScaledJobPublicApiController_resumeScaledJobByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Resume job deployment","tags":["Serverless Jobs"]}},"/v1/job-deployments/{jobName}/status":{"get":{"operationId":"ScaledJobPublicApiController_getScaledJobStatusByName","parameters":[{"name":"jobName","required":true,"in":"path","description":"Name of the job","schema":{"example":"my-job","type":"string"}}],"responses":{"200":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetScaledJobStatusResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get job deployment status","tags":["Serverless Jobs"]}},"/v1/container-deployments":{"get":{"operationId":"PublicApiController_getDeploymentsList","parameters":[],"responses":{"200":{"description":"Fetch a list of deployments","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get all deployments","tags":["Serverless Containers"]},"post":{"operationId":"PublicApiController_createNewDeployment","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateDeploymentPublicApiDto"}}}},"responses":{"201":{"description":"Returns the created deployment","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentPublicApiResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Create new deployment","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}":{"get":{"operationId":"PublicApiController_getDeploymentByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"200":{"description":"Fetch a deployment by name","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentPublicApiResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get deployment by name","tags":["Serverless Containers"]},"patch":{"operationId":"PublicApiController_updateDeploymentByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchDeploymentPublicApiDto"}}}},"responses":{"200":{"description":"Returns the updated deployment","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentPublicApiResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Update deployment","tags":["Serverless Containers"]},"delete":{"operationId":"PublicApiController_deleteDeploymentByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}},{"name":"timeout","required":false,"in":"query","description":"Maximum time to wait for deployment deletion in milliseconds. Set to 0 to skip waiting.","schema":{"minimum":0,"maximum":300000,"default":60000,"example":60000,"type":"number"}}],"responses":{"200":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Delete deployment","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/status":{"get":{"operationId":"PublicApiController_getReplicasStatusByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"200":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetDeploymentStatusResponseDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get deployment status","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/restart":{"post":{"operationId":"PublicApiController_restartDeploymentByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Restart deployment","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/scaling":{"get":{"operationId":"PublicApiController_getDeploymentScalingOptionsByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"200":{"description":"Scaling options","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScalingOptionsPublicApiDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get deployment scaling options by deployment name","tags":["Serverless Containers"]},"patch":{"operationId":"PublicApiController_updateDeploymentScalingOptionsByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PatchScalingOptionsPublicApiDto"}}}},"responses":{"200":{"description":"Returns the updated scaling options","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScalingOptionsPublicApiDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Update deployment scaling options","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/replicas":{"get":{"operationId":"PublicApiController_getDeploymentReplicasByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"200":{"description":"List of replicas","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ReplicasPublicApiDto"}}}},"401":{"description":"Unauthorized"}},"summary":"Get deployment replicas by deployment name","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/purge-queue":{"post":{"operationId":"PublicApiController_purgeQueue","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Purge deployment queue","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/pause":{"post":{"operationId":"PublicApiController_pauseDeploymentByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Pause deployment","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/resume":{"post":{"operationId":"PublicApiController_resumeDeploymentByName","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Resume deployment","tags":["Serverless Containers"]}},"/v1/container-deployments/{deployment_name}/environment-variables":{"get":{"operationId":"PublicApiController_getDeploymentEnvironmentVariables","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"responses":{"200":{"description":"Returns the environment variables for all containers of the deployment","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetDeploymentEnvVariablesPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get deployment environment variables","tags":["Serverless Containers"]},"post":{"operationId":"PublicApiController_addEnvironmentVariablesToContainer","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateOrPatchEnvironmentVariablesDto"}}}},"responses":{"200":{"description":"Returns the environment variables for the container","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetDeploymentEnvVariablesPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Add environment variables to a container","tags":["Serverless Containers"]},"patch":{"operationId":"PublicApiController_updateEnvironmentVariablesOfContainer","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateOrPatchEnvironmentVariablesDto"}}}},"responses":{"200":{"description":"Returns the updated environment variables for the container","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetDeploymentEnvVariablesPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Update environment variables of a container. The env vars must exist in order to update them","tags":["Serverless Containers"]},"delete":{"operationId":"PublicApiController_deleteEnvironmentVariablesOfContainer","parameters":[{"name":"deployment_name","required":true,"in":"path","description":"Name of the deployment","schema":{"example":"my-deployment","type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteEnvironmentVariablesPublicApiDto"}}}},"responses":{"200":{"description":"Returns the remaining environment variables for the container","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetDeploymentEnvVariablesPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Delete environment variables of a container","tags":["Serverless Containers"]}},"/v1/serverless-compute-resources":{"get":{"operationId":"PublicApiController_getComputeAndAvailability","parameters":[],"responses":{"200":{"description":"A list of compute resources and their availability","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetComputeResourcesPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get compute resource types and availability","tags":["Serverless Containers"]}},"/v1/secrets":{"get":{"operationId":"PublicApiController_getSecrets","parameters":[],"responses":{"200":{"description":"A list of secrets","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetSecretsPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get secrets","tags":["Serverless Containers"]},"post":{"operationId":"PublicApiController_addSecret","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateSecretPublicApiDto"}}}},"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Create new secret","tags":["Serverless Containers"]}},"/v1/secrets/{secret_name}":{"delete":{"description":"Will error if the secret is used in a deployment","operationId":"PublicApiController_deleteSecret","parameters":[{"name":"secret_name","required":true,"in":"path","schema":{"type":"string"}},{"name":"force","required":false,"in":"query","description":"Force delete the secret, even if it is used in deployments. Dangerous! may cause deployments to fail","schema":{"example":true,"type":"boolean"}}],"responses":{"200":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Delete secret","tags":["Serverless Containers"]}},"/v1/file-secrets":{"get":{"description":"File secrets can be used as a secret mount storage","operationId":"PublicApiController_getFilesetSecrets","parameters":[],"responses":{"200":{"description":"A list of fileset secrets","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetFilesetSecretsPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get fileset secrets","tags":["Serverless Containers"]},"post":{"description":"File secrets can be used as a secret mount storage","operationId":"PublicApiController_addFilesetSecret","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateFilesetSecretPublicApiDto"}}}},"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Create new fileset secret","tags":["Serverless Containers"]}},"/v1/file-secrets/{secret_name}":{"delete":{"description":"Will error if the secret is used in a deployment","operationId":"PublicApiController_deleteFilesetSecret","parameters":[{"name":"secret_name","required":true,"in":"path","schema":{"type":"string"}},{"name":"force","required":false,"in":"query","description":"Force delete the secret, even if it is used in deployments. Dangerous! may cause deployments to fail","schema":{"example":true,"type":"boolean"}}],"responses":{"200":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Delete fileset secret","tags":["Serverless Containers"]}},"/v1/container-registry-credentials":{"get":{"operationId":"PublicApiController_getRegistryCredentials","parameters":[],"responses":{"200":{"description":"A list of registry credentials","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GetRegistryCredentialsPublicApiResponseDto"}}}}},"401":{"description":"Unauthorized"}},"summary":"Get all registry credentials","tags":["Serverless Containers"]},"post":{"operationId":"PublicApiController_addRegistryCredentials","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateRegistryCredentialsPublicApiDto"}}}},"responses":{"201":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Add registry credentials","tags":["Serverless Containers"]}},"/v1/container-registry-credentials/{credentials_name}":{"delete":{"operationId":"PublicApiController_deleteRegistryCredentials","parameters":[{"name":"credentials_name","required":true,"in":"path","schema":{"type":"string"}},{"name":"force","required":false,"in":"query","description":"Force delete the registry credentials, even if it is used in deployments. Dangerous! may cause deployments to fail","schema":{"example":true,"type":"boolean"}}],"responses":{"200":{"description":""},"401":{"description":"Unauthorized"}},"summary":"Delete registry credentials","tags":["Serverless Containers"]}}},"components":{"schemas":{"GetAccessTokenDto":{"type":"object","properties":{"grant_type":{"type":"string","enum":["client_credentials","refresh_token"],"example":"client_credentials"},"client_id":{"type":"string","example":"6a51jsgnISg6JOyE7wYZh"},"client_secret":{"type":"string","example":"TvSBFujsqloJb4Jbcezths1OPK9my3zodM3zot9Fn5"}},"required":["grant_type","client_id","client_secret"]},"RefreshAccessTokenPublicApiDto":{"type":"object","properties":{"grant_type":{"type":"string","enum":["client_credentials","refresh_token"],"example":"refresh_token"},"refresh_token":{"type":"string","example":"OU4O2BwA690cKg2OfGS8pgIfGSTD2vJ..."}},"required":["grant_type","refresh_token"]},"GetAccessTokenResponseDto":{"type":"object","properties":{"access_token":{"type":"string","example":"eyJhbGciOiJIUzI1NiI...","description":"Access token value"},"token_type":{"type":"string","example":"Bearer","description":"Token type"},"expires_in":{"type":"number","example":3600,"description":"Token expiration time in seconds"},"refresh_token":{"type":"string","example":"OU4O2BwA690cKg2OfGS8pgIfGSTD2vJ...","description":"Refresh token value"},"scope":{"type":"string","example":"cloud-api-v1","description":"Access scope"}},"required":["access_token","token_type","expires_in","refresh_token","scope"]},"PublicApiErrorResponseDto":{"type":"object","properties":{"code":{"type":"string","example":"invalid_request","enum":["invalid_request","unauthorized_request","insufficient_funds","forbidden_action","not_found","conflict","server_error","service_unavailable"]},"message":{"type":"string","description":"Error message"}},"required":["code","message"]},"BalanceResponseDto":{"type":"object","properties":{"amount":{"type":"number","description":"Project balance","example":1000},"currency":{"type":"string","enum":["usd","eur"],"default":"usd","description":"Currency type","example":"usd"}},"required":["amount","currency"]},"Os":{"type":"object","properties":{"id":{"type":"string","description":"Image id","example":"b631190a-ac6f-43ba-87b7-3722ad6e3a30"},"image_type":{"type":"string","description":"Image type","example":"ubuntu-24.04"},"name":{"type":"string","description":"Image name","example":"Ubuntu 24.04"},"is_default":{"type":"boolean","description":"Is default image","example":false},"details":{"description":"Image details","example":["Ubuntu 24.04","Minimal Image"],"type":"array","items":{"type":"string"}},"category":{"type":"string","description":"Image category","example":"ubuntu"},"is_cluster":{"type":"boolean","description":"Is cluster","example":false}},"required":["id","image_type","name","is_default","details","category","is_cluster"]},"ActivityVolumeDto":{"type":"object","properties":{"id":{"type":"string","example":"2f2471cb-77f4-4d0f-8ca5-766f9e5296eb"},"name":{"type":"string","example":"volume-1"},"created_at":{"type":"string","example":"2026-03-17T14:15:52.872Z"},"gb":{"type":"number","example":100},"is_shared_fs":{"type":"boolean","example":false},"template_type":{"type":"string","enum":["HDD","NVMe","HDD_Shared","NVMe_Shared","NVMe_Local_Storage","NVMe_Shared_Cluster","NVMe_OS_Cluster"],"example":"NVMe"},"location_code":{"type":"string","example":"FIN-01"}},"required":["id","name","created_at","gb","is_shared_fs","template_type","location_code"]},"ActivityComputeDto":{"type":"object","properties":{"id":{"type":"string","example":"98251374-c196-451f-bb3e-a96a5b3d6dd3"},"hostname":{"type":"string","example":"example-fin-01"},"compute_type":{"type":"string","example":"4A100.88V"},"is_cluster":{"type":"boolean","example":false},"ip":{"type":"string","example":"1.2.3.4","nullable":true},"os_volume_id":{"type":"string","example":"ed39f057-8236-47c7-a4fc-84ce56d54e4c","nullable":true},"location_code":{"type":"string","example":"FIN-01","nullable":true}},"required":["id","hostname","compute_type","is_cluster"]},"GetActivityJournalResponseDto":{"type":"object","properties":{"id":{"type":"string","example":"instance-log-123","description":"Event ID, unique within the project. Please note that it is not UUID but a combined string to identify the event."},"object_id":{"type":"string","example":"c29a3e24-400c-423f-bc73-3a6f91219f66","description":"ID of the object that the event is related to."},"object_type":{"type":"string","enum":["compute","volume"],"example":"compute","description":"Object type that the event is related to."},"action_code":{"type":"string","enum":["create","start","start:complete","shutdown:complete","shutdown","delete","delete:complete","attach","attach:complete","detach","detach:complete","clone","resize","rename","restore","transfer","trash","trash:complete","configure_spot","cancel","provisioning","running"],"example":"start","description":"Action that was performed on the object."},"actor_id":{"type":"string","example":"f735a685-5f9f-4357-96e4-859586171478","nullable":true,"description":"ID of the actor that performed the action. For some actions, such as spot discontinue, the actor is not available and assumed to be system."},"actor_email":{"type":"string","example":"user@datacrunch.io","nullable":true,"description":"Email of the actor that performed the action."},"project_id":{"type":"string","example":"7e81f23a-a4e3-428c-8126-5337b0118c9b","description":"ID of the project that the event is related to."},"timestamp":{"type":"string","example":"2026-03-17T14:15:52.872Z","description":"When the event happened."},"location_code":{"type":"string","example":"FIN-01","description":"Datacenter location code where the event happened or this object is located."},"request_origin":{"type":"string","example":"public-api-v1","description":"Origin of the request that caused the event. For example, public API, Console UI, or undefined for the internal system."},"request_ip":{"type":"string","example":"127.0.0.1","description":"IP address of the request that caused the event."},"error_message":{"type":"string","example":"GPU_QUOTA_EXCEEDED","description":"For error events, the error message"},"parent_id":{"type":"string","example":"compute-log-123","description":"For some events, for example attach volume during instance provisioning, the ID of the parent event."},"service":{"type":"string","example":"VolumeProvider","description":"For some events, the internal service that caused the event."},"target_location_code":{"type":"string","example":"ICE-01","description":"For cross-datacenter events, the location code of the target location."},"volume":{"description":"Associated volume object, if the object is a volume.","allOf":[{"$ref":"#/components/schemas/ActivityVolumeDto"}]},"compute":{"description":"Detailed compute object, if the object type is a compute.","allOf":[{"$ref":"#/components/schemas/ActivityComputeDto"}]},"target_volume_id":{"type":"string","example":"1b9b3445-6506-4447-a41d-9199e2c24572","description":"For some events, the ID of the target volume."},"target_volume":{"nullable":true,"description":"Associated target volume object","allOf":[{"$ref":"#/components/schemas/ActivityVolumeDto"}]},"target_compute_id":{"type":"string","example":"fbd80679-6617-4cd5-ba85-08b2d367048c","description":"For some events, the ID of the target compute."},"target_compute":{"nullable":true,"description":"Associated target compute object","allOf":[{"$ref":"#/components/schemas/ActivityComputeDto"}]},"source_volume_id":{"type":"string","example":"47b174ea-050e-4bab-9b55-babfd9756fb7","description":"For some events, the ID of the source volume."},"source_volume":{"nullable":true,"description":"Associated source volume object","allOf":[{"$ref":"#/components/schemas/ActivityVolumeDto"}]},"source_compute_id":{"type":"string","example":"791de2b1-df96-4195-afc0-94bd6db54894","description":"For some events, the ID of the source compute."},"source_compute":{"nullable":true,"description":"Associated source compute object","allOf":[{"$ref":"#/components/schemas/ActivityComputeDto"}]},"properties":{"type":"object","example":{"delete_reason":"evicted_by_on_demand"},"additionalProperties":true,"description":"Additional properties of the event."}},"required":["id","object_id","object_type","action_code","project_id","timestamp","location_code"]},"GetVolumePublicResponseDto":{"type":"object","properties":{"id":{"type":"string","example":"03b07f44-d896-4ac4-9211-60f75332e56d","description":"Volume ID"},"instance_id":{"type":"string","example":"5bb59c01-0f42-4c17-aef1-f3f37740f097","description":"Instance ID"},"instances":{"description":"Instance info the volume is attached to","example":[{"id":"5bb59c01-0f42-4c17-aef1-f3f37740f097","auto_rental_extension":null,"ip":"123.123.123.123","instance_type":"4A100.88V","status":"running","os_volume_id":"6066f66e-ae50-4e48-bf35-61044733d56b","hostname":"hazy-star-swims-fin-01","instance_template":{"instance_type":"4A100.88V","cpu_cores":128,"gpu_number":4,"gpu_vram_gb":80,"ram_gb":512},"instance_model":{"code":"A100_80G","manufacturer":"NVIDIA","category":"GPU","cluster_model_code":null}}],"type":"array","items":{"type":"string"}},"name":{"type":"string","example":"OS-NVMe-84Ca37Jf","description":"Volume name"},"created_at":{"type":"string","example":"2024-07-08T19:19:54.247Z","description":"Volume creation date"},"created_by_user_id":{"type":"string","example":"7dfc2631-0158-4f74-93f6-6b46dcb90fef"},"status":{"type":"string","example":"attached","description":"Volume status","enum":["ordered","attached","attaching","detached","deleted","cloning","detaching","deleting","restoring","created","exported","canceled","canceling"]},"size":{"type":"number","example":100,"description":"Volume size in GB"},"is_os_volume":{"type":"boolean","example":true,"description":"Is OS volume"},"target":{"type":"string","example":"vda","description":"Volume target"},"type":{"type":"string","example":"NVMe","description":"Volume type","enum":["HDD","NVMe","HDD_Shared","NVMe_Shared","NVMe_Local_Storage","NVMe_Shared_Cluster","NVMe_OS_Cluster"]},"location":{"type":"string","example":"FIN-01","description":"Volume location"},"ssh_key_ids":{"example":["302602cf-71ac-4116-a6c0-2e5e5b1c30e5"],"description":"Array of SSH key IDs that are linked to the volume if it is an OS volume","type":"array","items":{"type":"string"}},"pseudo_path":{"type":"string","example":"volume-84Ca37Jf","description":"Volume pseudo path. Unique identifier for your filesystem"},"create_directory_command":{"type":"string","example":"mkdir -p /mnt/volume","description":"Create directory command"},"mount_command":{"type":"string","example":"mount -t nfs -o nconnect=16 nfs.fin-01.datacrunch.io:volume-88eb67d0 /mnt/volume","description":"Mount command"},"filesystem_to_fstab_command":{"type":"string","example":"grep -qxF 'nfs.fin-01.datacrunch.io:volume-88eb67d0 /mnt/volume nfs defaults 0 0' /etc/fstab || echo 'nfs.fin-01.datacrunch.io:volume-88eb67d0 /mnt/volume nfs defaults 0 0' | sudo tee -a /etc/fstab","description":"Filesystem to fstab command"},"contract":{"type":"string","examples":["LONG_TERM","PAY_AS_YOU_GO"],"description":"Volume contract type"},"base_hourly_cost":{"type":"number","example":0.0273972602739726,"description":"Volume base hourly cost"},"monthly_price":{"type":"number","example":20,"description":"Volume monthly price"},"currency":{"type":"string","example":"eur","description":"Volume currency","enum":["usd","eur"]},"long_term":{"type":"object","example":{"end_date":"2025-01-08T19:34:16.663Z","long_term_period":"3 months","discount_percentage":14,"auto_rental_extension":false,"next_period_price":49.93356,"current_period_price":49.93356},"description":"Long term contract details"}},"required":["id","instance_id","instances","name","created_at","status","size","is_os_volume","target","type","location","ssh_key_ids","pseudo_path","create_directory_command","mount_command","filesystem_to_fstab_command","contract","base_hourly_cost","monthly_price","currency","long_term"]},"GetVolumeInTrashPublicResponseDto":{"type":"object","properties":{"id":{"type":"string","example":"03b07f44-d896-4ac4-9211-60f75332e56d","description":"Volume ID"},"instance_id":{"type":"string","example":"5bb59c01-0f42-4c17-aef1-f3f37740f097","description":"Instance ID"},"instances":{"description":"Instance info the volume is attached to","example":[{"id":"5bb59c01-0f42-4c17-aef1-f3f37740f097","auto_rental_extension":null,"ip":"123.123.123.123","instance_type":"4A100.88V","status":"running","os_volume_id":"6066f66e-ae50-4e48-bf35-61044733d56b","hostname":"hazy-star-swims-fin-01","instance_template":{"instance_type":"4A100.88V","cpu_cores":128,"gpu_number":4,"gpu_vram_gb":80,"ram_gb":512},"instance_model":{"code":"A100_80G","manufacturer":"NVIDIA","category":"GPU","cluster_model_code":null}}],"type":"array","items":{"type":"string"}},"name":{"type":"string","example":"OS-NVMe-84Ca37Jf","description":"Volume name"},"created_at":{"type":"string","example":"2024-07-08T19:19:54.247Z","description":"Volume creation date"},"status":{"type":"string","example":"attached","description":"Volume status","enum":["ordered","attached","attaching","detached","deleted","cloning","detaching","deleting","restoring","created","exported","canceled","canceling"]},"size":{"type":"number","example":100,"description":"Volume size in GB"},"is_os_volume":{"type":"boolean","example":true,"description":"Is OS volume"},"target":{"type":"string","example":"vda","description":"Volume target"},"type":{"type":"string","example":"NVMe","description":"Volume type","enum":["HDD","NVMe","HDD_Shared","NVMe_Shared","NVMe_Local_Storage","NVMe_Shared_Cluster","NVMe_OS_Cluster"]},"location":{"type":"string","example":"FIN-01","description":"Volume location"},"ssh_key_ids":{"example":["302602cf-71ac-4116-a6c0-2e5e5b1c30e5"],"description":"Array of SSH key IDs that are linked to the volume if it is an OS volume","type":"array","items":{"type":"string"}},"contract":{"type":"string","examples":["LONG_TERM","PAY_AS_YOU_GO"],"description":"Volume contract type"},"base_hourly_cost":{"type":"number","example":0.0273972602739726,"description":"Volume base hourly cost"},"monthly_price":{"type":"number","example":20,"description":"Volume monthly price"},"currency":{"type":"string","example":"eur","description":"Volume currency","enum":["usd","eur"]},"deleted_at":{"type":"string","example":"2025-01-10T11:35:47.633Z","description":"Volume deletion date"},"is_permanently_deleted":{"type":"boolean","example":false,"description":"Is volume permanently deleted"}},"required":["id","instance_id","instances","name","created_at","status","size","is_os_volume","target","type","location","ssh_key_ids","contract","base_hourly_cost","monthly_price","currency","deleted_at","is_permanently_deleted"]},"CreateVolumePublicDto":{"type":"object","properties":{"type":{"type":"string","enum":["HDD","NVMe","HDD_Shared","NVMe_Shared","NVMe_Local_Storage","NVMe_Shared_Cluster","NVMe_OS_Cluster"],"description":"Volume type","example":"NVMe"},"location_code":{"type":"string","example":"FIN-01","description":"Location code"},"size":{"type":"number","example":50,"description":"Volume size in GB"},"instance_id":{"type":"string","example":"8831871c-049b-433c-83ae-3f1d5fcde733","description":"Instance ID to attach the volume to"},"instance_ids":{"example":["a5f68609-61e6-4ce0-9144-9524c15f99b7","111c2573-d1bb-46d4-8931-a8a72fcc7fd3"],"description":"Array of instance IDs to attach the volume to","type":"array","items":{"type":"string"}},"name":{"type":"string","example":"my-volume","description":"Volume name"}},"required":["type","location_code","size","name"]},"PerformVolumeActionPublicDto":{"type":"object","properties":{"action":{"type":"string","enum":["attach","detach","delete","rename","resize","restore","clone","cancel","create","export","transfer"],"description":"Action to perform on the volume(s)\n\nThe `clone` action returns its destination volume ID: `{\"id\":\"...\"}`. Send a `cancel` action with that same ID to interrupt a cross-datacenter clone.","example":"detach"},"id":{"example":["90612882-54eb-42c0-ba78-feb5f8b89809"],"description":"Volume ID(s) to perform the action on. Single volume id or an array of volume ids","oneOf":[{"type":"string","format":"uuid"},{"type":"array","items":{"type":"string","format":"uuid"}}]},"size":{"type":"number","example":100,"description":"New volume size in GB. Can't be lower than current size"},"instance_id":{"type":"string","example":"f9b147cb-13ce-4d1d-b14b-ee2f1a69ae65","description":"Instance ID to attach the volume to, if the action is attach"},"instance_ids":{"example":["bafa5fcd-730f-45fd-b766-f2a763cbd967","58a57a3f-2162-4ef3-99e2-365a2b202ffc"],"description":"Array of instance IDs to attach the volume to, if the action is attach","type":"array","items":{"type":"string"}},"name":{"type":"string","example":"volume-name","description":"New volume name"},"type":{"type":"string","example":"NVMe","description":"Target volume type"},"is_permanent":{"type":"boolean","example":true,"description":"If deleting volume(s), delete them permanently"},"location_code":{"type":"string","example":"FIN-01","description":"Target location code if cloning the volume"}},"required":["action","id"]},"DeleteVolumePublicDto":{"type":"object","properties":{"is_permanent":{"type":"boolean","example":false,"default":false,"description":"If true, the volume will be removed permanently"}}},"VolumeType":{"type":"object","properties":{"type":{"type":"string","description":"Volume type","example":"NVMe","enum":["HDD","NVMe","HDD_Shared","NVMe_Shared","NVMe_Local_Storage","NVMe_Shared_Cluster","NVMe_OS_Cluster"]},"price":{"type":"object","description":"Price details","example":{"price_per_month_per_gb":0.2,"cps_per_gb":7.6103500761035e-8,"currency":"usd"}},"is_shared_fs":{"type":"boolean","description":"Is shared file system","example":false},"burst_bandwidth":{"type":"number","description":"Burst bandwidth","example":2500},"continuous_bandwidth":{"type":"number","description":"Continuous bandwidth","example":2000},"internal_network_speed":{"type":"number","description":"Internal network speed","example":50},"iops":{"type":"string","description":"IOPS","example":"100k"},"throughput_gbps":{"type":"number","description":"Throughput in GB/s","example":4}},"required":["type","price","is_shared_fs","burst_bandwidth","continuous_bandwidth","internal_network_speed","iops","throughput_gbps"]},"GetInstanceResponsePublicApiDto":{"type":"object","properties":{"id":{"type":"string","example":"ed987653-24c4-4959-8ed0-bb77b5ec2687"},"ip":{"type":"string","example":"1.2.3.4"},"status":{"type":"string","enum":["running","provisioning","offline","discontinued","unknown","ordered","notfound","new","error","deleting","validating","no_capacity","installation_failed"],"example":"running"},"created_at":{"type":"string","example":"2023-07-15T14:10:26.654Z"},"created_by_user_id":{"type":"string","example":"7dfc2631-0158-4f74-93f6-6b46dcb90fef"},"cpu":{"type":"object","example":{"description":"176 CPU","number_of_cores":176}},"gpu":{"type":"object","example":{"description":"8x A100","number_of_gpus":8}},"gpu_memory":{"type":"object","example":{"description":"80GB GPU RAM","size_in_gigabytes":80}},"memory":{"type":"object","example":{"description":"640GB RAM","size_in_gigabytes":640}},"storage":{"type":"object","example":{"description":"dynamic"}},"hostname":{"type":"string","example":"hazy-star-swims-fin-01"},"description":{"type":"string","example":"ubuntu-22-04-cuda-12-0-docker-fin-01"},"location":{"type":"string","example":"FIN-01"},"price_per_hour":{"type":"number","example":2.481},"is_spot":{"type":"boolean","example":false},"instance_type":{"type":"string","example":"8A100.176V"},"image":{"type":"string","example":"ubuntu-22-04-cuda-12-0-docker"},"os_name":{"type":"string","example":"Ubuntu 22.04"},"startup_script_id":{"type":"string","example":"95cec4c3-af69-42eb-a790-fcacebfdfcea"},"ssh_key_ids":{"example":["dd50b622-1c36-48c2-a485-f4d4937a3ea1"],"type":"array","items":{"type":"string"}},"os_volume_id":{"type":"string","example":"95cec4c3-af69-42eb-a790-fcacebfdfcea"},"jupyter_token":{"type":"string","example":"b9e6d8517db3a722ccfb309ca599a35f"},"contract":{"type":"string","enum":["LONG_TERM","PAY_AS_YOU_GO","SPOT"],"example":"PAY_AS_YOU_GO"},"pricing":{"type":"string","enum":["DYNAMIC_PRICE","FIXED_PRICE"],"example":"FIXED_PRICE"},"volume_ids":{"example":["95cec4c3-af69-42eb-a790-fcacebfdfcea","dd50b622-1c36-48c2-a485-f4d4937a3ea1"],"type":"array","items":{"type":"string"}}},"required":["id","ip","status","created_at","cpu","gpu","gpu_memory","memory","storage","hostname","description","location","price_per_hour","is_spot","instance_type","image","os_name","startup_script_id","ssh_key_ids","os_volume_id","jupyter_token","contract","pricing","volume_ids"]},"OsVolumeDto":{"type":"object","properties":{"name":{"type":"string","example":"custom-os-volume-name"},"size":{"type":"number","example":"100"},"on_spot_discontinue":{"type":"string","enum":["keep_detached","move_to_trash","delete_permanently"],"description":"Optional, by default, nothing is deleted. Should we automatically delete, if instance is deleted because of spot?\nAllowed values:\n\n * `keep_detached` (default behavior, volume will be detached),\n * `move_to_trash` (will be deleted after 96 hours and counts towards the storage volume quota),\n * `delete_permanently` (will be deleted immediately)."}},"required":["name","size"]},"VolumeDto":{"type":"object","properties":{"name":{"type":"string","example":"custom-os-volume-name"},"size":{"type":"number","example":"100"},"on_spot_discontinue":{"type":"string","enum":["keep_detached","move_to_trash","delete_permanently"],"description":"Optional, by default, nothing is deleted. Should we automatically delete, if instance is deleted because of spot?\nAllowed values:\n\n * `keep_detached` (default behavior, volume will be detached),\n * `move_to_trash` (will be deleted after 96 hours and counts towards the storage volume quota),\n * `delete_permanently` (will be deleted immediately)."},"type":{"type":"string","enum":["HDD","NVMe","HDD_Shared","NVMe_Shared","NVMe_Local_Storage","NVMe_Shared_Cluster","NVMe_OS_Cluster"]}},"required":["name","size","type"]},"DeployInstancePublicDto":{"type":"object","properties":{"instance_type":{"type":"string","example":"1H100.80S.30V"},"image":{"type":"string","description":"OS image specification for the created instance. There are two options:\n\n1. OS image type. For a list of supported images, check `GET /images` endpoint, `\"image_type\"` property. To set the name and size, use `\"os_volume\"` property.\n2. Previously customized OS volume ID. (To create an OS volume, first make an instance with existing `\"image\"` type.\nTo customize the volume content, ssh into that instance. Finally, delete the instance but keep the volume.)","examples":["ubuntu-22.04-cuda-12.4-docker","fbec3adb-4057-46e8-a7a2-a75acdef87a8"]},"ssh_key_ids":{"example":["5f65bf99-4275-4c4c-af24-7aa10c49a601"],"oneOf":[{"type":"string","format":"uuid"},{"type":"array","items":{"type":"string","format":"uuid"}}]},"startup_script_id":{"type":"string","example":"8923967f-97fa-4193-88a0-ce9ef082b032"},"hostname":{"type":"string","example":"my-instance-hostname"},"description":{"type":"string"},"location_code":{"type":"string","example":"FIN-01","description":"Location code for the instance and any newly created volumes"},"os_volume":{"description":"Newly created OS volume name and size (in GB). Use when `\"image\"` property is an OS image type.\n\nObject properties:\n  * `name` - Name of the OS volume\n  * `size` - Size of the OS volume in GB\n  * `on_spot_discontinue` - Removal policy for the OS volume for spot instances. Optional, by default, nothing is deleted. Allowed values: `keep_detached` (default behavior), `move_to_trash` (will be deleted after 96 hours and counts towards the storage volume quota), `delete_permanently` (will be deleted immediately).\n    ","example":{"name":"custom-os-volume-name","size":100,"on_spot_discontinue":"keep_detached"},"allOf":[{"$ref":"#/components/schemas/OsVolumeDto"}]},"is_spot":{"type":"boolean","description":"Create a spot instance. Spot instances may be evicted by Verda at any time without warning."},"coupon":{"type":"string","example":"COUPON-CODE-2026"},"volumes":{"description":"Additional (**non-OS**) volumes to create and attach to this new instance.\n    \n  (To configure **OS** volume, use `\"image\"` and `\"os_volume\"` properties.)","example":[{"name":"additional-volume-name","size":1000,"type":"NVMe"}],"type":"array","items":{"$ref":"#/components/schemas/VolumeDto"}},"existing_volumes":{"description":"IDs of additional existing detached volumes to attach to this new instance when its created.\n\n(To configure instance **OS** volume, use `\"image\"` and `\"os_volume\"` properties.)","example":["588716d0-004c-46f3-ae62-994f91eaedbf"],"type":"array","items":{"type":"string"}},"contract":{"type":"string","example":"PAY_AS_YOU_GO","enum":["LONG_TERM","PAY_AS_YOU_GO","SPOT"]},"pricing":{"type":"string","deprecated":true,"example":"FIXED_PRICE","enum":["DYNAMIC_PRICE","FIXED_PRICE"],"description":"This field is deprecated as DYNAMIC_PRICE is removed. Only FIXED_PRICE is supported now."}},"required":["instance_type","image","hostname","description","location_code"]},"PerformInstanceActionPublicDto":{"type":"object","properties":{"action":{"type":"string","enum":["boot","start","shutdown","delete","discontinue","hibernate","configure_spot","force_shutdown","delete_stuck","deploy","transfer"]},"id":{"example":["debfa4fa-245c-4c82-b05b-70f4cd83d435"],"description":"Instance ID or list of instance IDs","oneOf":[{"type":"string","format":"uuid"},{"type":"array","items":{"type":"string","format":"uuid"}}]},"volume_ids":{"example":["e130a07e-687a-44ae-91d2-64ad760fc2d4"],"description":"Volume IDs to delete. Specify empty array to indicate no volumes should be deleted (previously known as \"hibernate\")","type":"array","items":{"type":"string"}},"delete_permanently":{"type":"boolean","description":"Delete the volumes permanently. Only applicable for delete (or discontinue) action, when volume IDs to delete are also provided.","default":false}},"required":["action","id"]},"InstanceActionResultDto":{"type":"object","properties":{"instanceId":{"type":"string","description":"Instance ID","format":"uuid"},"action":{"type":"string","enum":["boot","start","shutdown","delete","discontinue","hibernate","configure_spot","force_shutdown","delete_stuck","deploy","transfer"],"description":"Action that was requested"},"status":{"type":"string","enum":["success","error"],"description":"Whether the action succeeded or failed"},"error":{"type":"string","description":"Error message if the action failed"},"statusCode":{"type":"number","description":"HTTP status code of the error","example":400}},"required":["instanceId","action","status"]},"GetClusterResponsePublicApiDto":{"type":"object","properties":{"id":{"type":"string","example":"17786b52-e5ba-4edb-9430-f8d2181819ea"},"ip":{"type":"string","example":"1.2.3.4","description":"Jump host IP address"},"status":{"type":"string","enum":["running","provisioning","offline","discontinued","unknown","ordered","notfound","new","error","deleting","validating","no_capacity","installation_failed"],"example":"running"},"created_at":{"type":"string","example":"2023-07-15T14:10:26.654Z"},"created_by_user_id":{"type":"string","example":"7dfc2631-0158-4f74-93f6-6b46dcb90fef"},"cpu":{"type":"object","example":{"description":"176 CPU","number_of_cores":176}},"gpu":{"type":"object","example":{"description":"8x A100","number_of_gpus":8}},"gpu_memory":{"type":"object","example":{"description":"80GB GPU RAM","size_in_gigabytes":80}},"memory":{"type":"object","example":{"description":"640GB RAM","size_in_gigabytes":640}},"hostname":{"type":"string","example":"hazy-star-swims-fin-01"},"description":{"type":"string","example":"ubuntu-22-04-cuda-12-0-docker-fin-01"},"location":{"type":"string","example":"FIN-01"},"price_per_hour":{"type":"number","example":2.481},"cluster_type":{"type":"string","example":"16H200"},"image":{"type":"string","example":"ubuntu-22-04-cuda-12-0-docker","description":"OS image used to deploy the cluster nodes"},"os_name":{"type":"string","example":"Ubuntu 22.04"},"startup_script_id":{"type":"string","example":"95cec4c3-af69-42eb-a790-fcacebfdfcea"},"ssh_key_ids":{"example":["dd50b622-1c36-48c2-a485-f4d4937a3ea1"],"description":"SSH key IDs used to access the cluster jump host","type":"array","items":{"type":"string"}},"contract":{"type":"string","description":"Contract type used for this cluster","enum":["LONG_TERM","PAY_AS_YOU_GO"],"example":"LONG_TERM"},"auto_rental_extension":{"type":"boolean","example":false,"deprecated":true,"description":"Deprecated: use extension_settings instead."},"turn_to_pay_as_you_go":{"type":"boolean","example":false,"deprecated":true,"description":"Deprecated: use extension_settings instead."},"extension_settings":{"type":"string","enum":["auto_renew","pay_as_you_go","end_contract"],"description":"Extension settings for long-term contracts"},"long_term_period":{"type":"string","example":"1 week","description":"Long-term rental period for this cluster, e.g. 1 week etc."},"worker_nodes":{"description":"Worker nodes of this cluster. You can access them from the jump host by executing `ssh <hostname>`","example":[{"id":"1","hostname":"worker-1","public_ip":"1.2.3.4","private_ip":"1.2.3.4","status":"running"}],"type":"array","items":{"type":"string"}},"shared_volumes":{"description":"Shared volumes attached to this cluster. There is always one shared volume mounted as /home.","example":[{"id":"1","name":"shared-volume-1","mount_point":"/home","size_in_gigabytes":100}],"type":"array","items":{"type":"string"}}},"required":["id","ip","status","created_at","cpu","gpu","gpu_memory","memory","hostname","description","location","price_per_hour","cluster_type","image","os_name","ssh_key_ids","contract"]},"SharedVolumeDto":{"type":"object","properties":{"name":{"type":"string","example":"SFS-pmAna3o2","description":"Name of the shared cluster volume"},"size":{"type":"number","example":30000,"description":"Size of the shared cluster volume in GB"}},"required":["name","size"]},"ExistingSharedVolumeDto":{"type":"object","properties":{"id":{"type":"string","example":"eef5a018-0516-40ef-aea1-d7ea02a3d77b","description":"Existing shared volume ID"}},"required":["id"]},"DeployClusterPublicDto":{"type":"object","properties":{"cluster_type":{"type":"string","description":"Cluster instance type. Can be listed using the `GET /v1/cluster-types` endpoint.","example":"16H200"},"image":{"type":"string","description":"OS image specification for the cluster. For a list of supported images, check `GET /v1/images/cluster` endpoint, `\"image_type\"` property.","examples":["ubuntu-22.04-cuda-12.4-cluster","dc6d6299-b1bb-49de-8a7f-fa0008ddadd0"]},"ssh_key_ids":{"example":["d52352b4-3149-418f-8298-bc73a5669216"],"description":"SSH key IDs to attach to the cluster. Required if image is an OS image type.","oneOf":[{"type":"string","format":"uuid"},{"type":"array","items":{"type":"string","format":"uuid"}}]},"startup_script_id":{"type":"string","example":"f5a81835-0a4a-43ce-9802-03fcc7828dde","description":"Startup script ID to run on cluster initialization"},"hostname":{"type":"string","example":"dark-vm-shrinks-fin-01"},"description":{"type":"string","example":"ubuntu-22-04-cuda-12-4-16b200-fin-01"},"location_code":{"type":"string","example":"FIN-01","description":"Location code for the cluster and its shared volume"},"contract":{"type":"string","enum":["PAY_AS_YOU_GO","LONG_TERM"],"example":"PAY_AS_YOU_GO","description":"Contract type. For clusters, only PAY_AS_YOU_GO currently supported."},"extension_settings":{"type":"string","enum":["auto_renew","pay_as_you_go","end_contract"],"description":"Extension settings for long-term contracts. Takes priority over auto_rental_extension and turn_to_pay_as_you_go."},"auto_rental_extension":{"type":"boolean","deprecated":true,"description":"Deprecated: use extension_settings instead. Enable automatic rental extension for long-term contracts."},"turn_to_pay_as_you_go":{"type":"boolean","deprecated":true,"description":"Deprecated: use extension_settings instead. Automatically convert to pay-as-you-go after the long-term period ends."},"shared_volume":{"description":"Shared cluster volume (SFS) specification. Clusters have one shared volume mounted as /home. The OS volume is ephemeral and created automatically by the system. ","example":{"name":"cluster-volume-name","size":30000},"allOf":[{"$ref":"#/components/schemas/SharedVolumeDto"}]},"existing_volumes":{"description":"Existing shared volumes to attach to the cluster. Should be in the same location as the cluster. Must be previously created and attached to the cluster.","example":[],"type":"array","items":{"$ref":"#/components/schemas/ExistingSharedVolumeDto"}}},"required":["cluster_type","image","hostname","description","location_code","shared_volume"]},"DeployClusterResponsePublicApiDto":{"type":"object","properties":{"id":{"type":"string","example":"36ad2d7d-55d6-4f87-9339-7bab164e0b00"}},"required":["id"]},"PerformClusterActionPublicDto":{"type":"object","properties":{"action":{"type":"string","enum":["discontinue"],"example":"discontinue"},"id":{"type":"string","example":"3df6d3cc-dac3-403a-b21e-194c1fbab42f","description":"Cluster ID"}},"required":["action","id"]},"PerformClusterActionsBulkDto":{"type":"object","properties":{"actions":{"description":"Array of cluster actions, one per each cluster","example":[{"action":"discontinue","id":"a80725d1-de6d-43ee-8f0f-41e575806c16"},{"action":"discontinue","id":"e548a53e-b63e-4fe4-b4f6-98db40e0b6b0"}],"type":"array","items":{"$ref":"#/components/schemas/PerformClusterActionPublicDto"}}},"required":["actions"]},"PerformClusterNodeActionPublicDto":{"type":"object","properties":{"action":{"type":"string","enum":["boot","shutdown","force_shutdown"],"example":"shutdown"}},"required":["action"]},"InstanceType":{"type":"object","properties":{"best_for":{"description":"Use cases for instance type","example":["Giant ML models","Multi-GPU training","FP64 calculations","NVLINK"],"type":"array","items":{"type":"string"}},"cpu":{"type":"object","description":"CPU details","example":{"description":"22 CPU","number_of_cores":22}},"deploy_warning":{"type":"string","description":"Deploy warning","example":"Make sure your VM is running on latest Nvidia Driver 525.100+ or newer"},"description":{"type":"string","description":"Instance type description","example":"Dedicated Hardware Instance"},"gpu":{"type":"object","description":"GPU details","example":{"description":"1x H100 SXM5 80GB","number_of_gpus":1}},"gpu_memory":{"type":"object","description":"GPU memory details","example":{"description":"80GB GPU RAM","size_in_gigabytes":80}},"id":{"type":"string","description":"Instance type ID","example":"c01dd00d-0000-4972-ae4e-d429115d055b"},"instance_type":{"type":"string","description":"Instance type","example":"1H100.80S.22V"},"memory":{"type":"object","description":"Memory details","example":{"description":"187GB RAM","size_in_gigabytes":187}},"model":{"type":"string","description":"GPU model","example":"H100"},"name":{"type":"string","description":"GPU model name","example":"H100 SXM5 80GB"},"p2p":{"type":"string","description":"P2P details","example":"600 GB/s"},"price_per_hour":{"type":"string","description":"Price per hour","example":"3.17"},"spot_price":{"type":"string","description":"Spot price per hour","example":"0.31"},"dynamic_price":{"type":"string","description":"Current dynamic price","example":"1.25","deprecated":true},"max_dynamic_price":{"type":"string","description":"Ceiling value for dynamic price","example":"6.34","deprecated":true},"serverless_price":{"type":"string","description":"Current serverless price","example":"1.75"},"serverless_spot_price":{"type":"string","description":"Current serverless spot price","example":"0.87"},"storage":{"type":"object","description":"Storage details","example":{"description":"dynamic"}},"currency":{"type":"string","enum":["usd","eur"],"description":"Currency type","example":"usd"},"manufacturer":{"type":"string","description":"Manufacturer","example":"NVIDIA"},"display_name":{"type":"string","description":"Display name","example":"NVIDIA H100 SXM5 80GB"},"supported_os":{"description":"Supported OS image types","example":["ubuntu-22.04-cuda-12.3","ubuntu-24.04"],"type":"array","items":{"type":"string"}}},"required":["best_for","cpu","description","gpu","gpu_memory","id","instance_type","memory","model","name","p2p","price_per_hour","spot_price","max_dynamic_price","storage","currency","manufacturer","display_name","supported_os"]},"InstanceAvailabilityResponseDto":{"type":"object","properties":{"location_code":{"type":"string","description":"Location code","example":"FIN-01"},"availabilities":{"description":"Array of available instance types","example":["1H100.80S.22V","2H100.80S.60V","4H100.80S.176V","8H100.80S.352V"],"type":"array","items":{"type":"string"}}},"required":["location_code","availabilities"]},"ClusterAvailabilityResponseDto":{"type":"object","properties":{"location_code":{"type":"string","description":"Location code","example":"FIN-01"},"availabilities":{"description":"Array of available cluster types","example":["16H200","32H200"],"type":"array","items":{"type":"string"}}},"required":["location_code","availabilities"]},"GetKeysResponseDto":{"type":"object","properties":{"id":{"type":"string","description":"SSH key id","example":"f7b3b3b3-1b3b-4b3b-8b3b-3b3b3b3b3b3b"},"name":{"type":"string","description":"Name of the SSH key","example":"my-key"},"key":{"format":"date-time","type":"string","description":"Public SSH key","example":"ssh-rsa AAAAB3Nz
[...]
